{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE Rank2Types #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Curry_ModuleDeps ( C_ModuleIdent, C_Errors, C_Source, d_C_deps ) where

import Basics
import qualified Curry_Char
import qualified Curry_CompilerOpts
import qualified Data.Curry_FiniteMap
import qualified Data.Curry_SCC
import qualified Curry_Directory
import qualified Curry_Distribution
import qualified Curry_FilePath
import qualified Curry_Files
import qualified FlatCurry.Annotated.Curry_Files
import qualified FlatCurry.Annotated.Curry_Types
import qualified Curry_Function
import qualified Curry_IO
import qualified Curry_Installation
import qualified Curry_List
import qualified Curry_Maybe
import qualified Curry_Message
import qualified Curry_Names
import qualified Curry_Prelude
import qualified Curry_RCFile
import qualified Curry_System
import qualified System.Curry_CurryPath
import qualified System.Curry_FrontendExec
import qualified Curry_Time


type C_ModuleIdent = Curry_Prelude.OP_List Curry_Prelude.C_Char

type C_Errors = Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)

type C_Source = Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)

type C_SourceEnv = Data.Curry_FiniteMap.C_FM (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)))

d_C_deps :: Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char))))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
d_C_deps x1 x2 x3 cd cs =
  Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_sourceDeps x1 x2 x3 (Data.Curry_FiniteMap.d_C_emptyFM
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_lbracket_rbracket
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Ord_hash_Prelude_dot_Char cd
  cs) cd cs) cd cs) cd cs) (d_OP_deps_dot_uscore_hash_lambda3 x3 x2) cd cs

d_OP_deps_dot_uscore_hash_lambda3 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Data.Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)))) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
d_OP_deps_dot_uscore_hash_lambda3 x1 x2 x3 cd cs = let x4 = x3
                                                       x5 = d_C_filterMissing x4
                                                         cd cs
                                                       x6 = d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP5_hash_mods1
                                                         x5 cd cs
                                                       x7 = d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP6_hash_errs1
                                                         x5 cd cs
                                                       x8 = Curry_Prelude.d_C_apply
                                                         (d_C_flattenDeps cd cs)
                                                         x6 cd cs
                                                       x9 = d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP3_hash_mods2
                                                         x8 cd cs
                                                       x10 = d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP4_hash_errs2
                                                         x8 cd cs
  in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_checkTypedFlatCurry x2 x1 cd cs)
  (d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_lambda5 x7 x10 x9) cd cs

nd_OP_deps_dot_uscore_hash_lambda3 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Data.Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char))))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
nd_OP_deps_dot_uscore_hash_lambda3 x1 x2 x3 s cd cs = let s3 = s
  in s3 `seq` (let s0 = leftSupply s3
                   s4 = rightSupply s3
                   s1 = leftSupply s4
                   s2 = rightSupply s4
  in s0 `seq` (s4 `seq` (s1 `seq` (s2 `seq` (let x4 = x3
                                                 x5 = nd_C_filterMissing x4 s0
                                                   cd cs
                                                 x6 = d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP5_hash_mods1
                                                   x5 cd cs
                                                 x7 = d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP6_hash_errs1
                                                   x5 cd cs
                                                 x8 = Curry_Prelude.nd_C_apply
                                                   (wrapDX id (d_C_flattenDeps
                                                   cd cs)) x6 s1 cd cs
                                                 x9 = d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP3_hash_mods2
                                                   x8 cd cs
                                                 x10 = d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP4_hash_errs2
                                                   x8 cd cs
  in Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_checkTypedFlatCurry x2 x1 cd cs) (wrapDX id
  (d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_lambda5 x7 x10 x9)) s2 cd
  cs)))))

d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP5_hash_mods1 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char))))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)))
d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP5_hash_mods1 x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP5_hash_mods1 l cd
    cs) (d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP5_hash_mods1 r
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP5_hash_mods1 z cd cs)
    xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP5_hash_mods1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps.deps._#lambda3._#selFP5#mods1" [show x1] info)
  _ -> failCons cd (consFail "ModuleDeps.deps._#lambda3._#selFP5#mods1"
    (showCons x1))

d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP6_hash_errs1 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char))))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP6_hash_errs1 x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP6_hash_errs1 l cd
    cs) (d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP6_hash_errs1 r
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP6_hash_errs1 z cd cs)
    xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP6_hash_errs1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps.deps._#lambda3._#selFP6#errs1" [show x1] info)
  _ -> failCons cd (consFail "ModuleDeps.deps._#lambda3._#selFP6#errs1"
    (showCons x1))

d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP3_hash_mods2 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char))))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)))
d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP3_hash_mods2 x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP3_hash_mods2 l cd
    cs) (d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP3_hash_mods2 r
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP3_hash_mods2 z cd cs)
    xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP3_hash_mods2 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps.deps._#lambda3._#selFP3#mods2" [show x1] info)
  _ -> failCons cd (consFail "ModuleDeps.deps._#lambda3._#selFP3#mods2"
    (showCons x1))

d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP4_hash_errs2 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char))))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP4_hash_errs2 x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP4_hash_errs2 l cd
    cs) (d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP4_hash_errs2 r
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP4_hash_errs2 z cd cs)
    xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_selFP4_hash_errs2 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps.deps._#lambda3._#selFP4#errs2" [show x1] info)
  _ -> failCons cd (consFail "ModuleDeps.deps._#lambda3._#selFP4#errs2"
    (showCons x1))

d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_lambda5 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)))) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
d_OP_deps_dot_uscore_hash_lambda3_dot_uscore_hash_lambda5 x1 x2 x3 x4 cd cs =
  let x5 = x4
  in Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Prelude.OP_Tuple2 x3 (Curry_Prelude.d_C_concat (Curry_Prelude.OP_Cons
  x1 (Curry_Prelude.OP_Cons x2 (Curry_Prelude.OP_Cons x5
  Curry_Prelude.OP_List))) cd cs)) cd cs

d_C_checkTypedFlatCurry :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C_checkTypedFlatCurry x1 x2 cd cs = d_C__case_19 x2 x1
  (d_C_isTypedFlatCurryFile x2 cd cs) cd cs

d_OP_checkTypedFlatCurry_dot_uscore_hash_lambda9 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_checkTypedFlatCurry_dot_uscore_hash_lambda9 x1 x2 x3 cd cs = let x4 = x3
  in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Directory.d_C_doesFileExist x2 cd cs)
  (d_OP_checkTypedFlatCurry_dot_uscore_hash_lambda9_dot_uscore_hash_lambda11 x4
  x1 x2) cd cs

d_OP_checkTypedFlatCurry_dot_uscore_hash_lambda9_dot_uscore_hash_lambda11 :: Curry_Prelude.C_Bool
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_checkTypedFlatCurry_dot_uscore_hash_lambda9_dot_uscore_hash_lambda11 x1 x2 x3 x4 cd cs =
  let x5 = x4
  in d_C__case_17 x5 x1 x3 x2 (Curry_Prelude.d_OP_amp_amp x1 x5 cd cs) cd cs

d_OP_checkTypedFlatCurry_dot_uscore_hash_lambda9_dot_uscore_hash_lambda11_dot_uscore_hash_lambda15 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Time.C_ClockTime -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_checkTypedFlatCurry_dot_uscore_hash_lambda9_dot_uscore_hash_lambda11_dot_uscore_hash_lambda15 x1 x2 x3 cd cs =
  let x4 = x3
  in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Directory.d_C_getModificationTime x2 cd cs)
  (d_OP_checkTypedFlatCurry_dot_uscore_hash_lambda9_dot_uscore_hash_lambda11_dot_uscore_hash_lambda15_dot_uscore_hash_lambda17
  x4 x1 x2) cd cs

d_OP_checkTypedFlatCurry_dot_uscore_hash_lambda9_dot_uscore_hash_lambda11_dot_uscore_hash_lambda15_dot_uscore_hash_lambda17 :: Curry_Time.C_ClockTime
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Time.C_ClockTime -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_checkTypedFlatCurry_dot_uscore_hash_lambda9_dot_uscore_hash_lambda11_dot_uscore_hash_lambda15_dot_uscore_hash_lambda17 x1 x2 x3 x4 cd cs =
  let x5 = x4
  in Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C__case_14 x1 x5 x2 x3 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Time.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Time_dot_ClockTime
  cd cs) x5 cd cs) x1 cd cs) cd cs) cd cs

d_C_moduleDeps :: Curry_CompilerOpts.C_Options -> Data.Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Data.Curry_FiniteMap.C_FM (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char))))
d_C_moduleDeps x1 x2 x3 cd cs = d_C__case_13 x3 x2 x1
  (Data.Curry_FiniteMap.d_C_lookupFM
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char cd
  cs) cd cs) x2 x3 cd cs) cd cs

nd_C_moduleDeps :: Curry_CompilerOpts.C_Options -> Data.Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Data.Curry_FiniteMap.C_FM (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char))))
nd_C_moduleDeps x1 x2 x3 s cd cs = let s6 = s
  in s6 `seq` (let s5 = leftSupply s6
                   s4 = rightSupply s6
  in s5 `seq` (s4 `seq` nd_C__case_13 x3 x2 x1 (let s3 = leftSupply s4
                                                    s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Data.Curry_FiniteMap.nd_C_lookupFM (let s1 = leftSupply
                                                                  s2
                                                                s0 = rightSupply
                                                                  s2
  in s1 `seq` (s0 `seq`
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char s0
  cd cs) s1 cd cs)) x2 x3 s3 cd cs)) s5 cd cs))

d_OP_moduleDeps_dot_uscore_hash_lambda21 :: Curry_CompilerOpts.C_Options
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Data.Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Data.Curry_FiniteMap.C_FM (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))))
d_OP_moduleDeps_dot_uscore_hash_lambda21 x1 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.C_Nothing -> Curry_Prelude.d_OP_dollar
    Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (Data.Curry_FiniteMap.d_C_addToFM
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char cd
    cs) cd cs) x3 x2 Curry_Prelude.C_Nothing cd cs) cd cs
  Curry_Prelude.C_Just x5 -> d_C_sourceDeps (d_C__case_12 x1 cd cs) x2 x5 x3 cd
    cs
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i
    (d_OP_moduleDeps_dot_uscore_hash_lambda21 x1 x2 x3 l cd cs)
    (d_OP_moduleDeps_dot_uscore_hash_lambda21 x1 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z ->
    d_OP_moduleDeps_dot_uscore_hash_lambda21 x1 x2 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c
    (d_OP_moduleDeps_dot_uscore_hash_lambda21 x1 x2 x3 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "ModuleDeps.moduleDeps._#lambda21" [show x1, show x2, show x3, show x4]
    info)
  _ -> failCons cd (consFail "ModuleDeps.moduleDeps._#lambda21" (showCons x4))

nd_OP_moduleDeps_dot_uscore_hash_lambda21 :: Curry_CompilerOpts.C_Options
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Data.Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Data.Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))))
nd_OP_moduleDeps_dot_uscore_hash_lambda21 x1 x2 x3 x4 s cd cs = case x4 of
  Curry_Prelude.C_Nothing -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_OP_dollar (wrapDX id
    Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO)
    (let s3 = leftSupply s4
         s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Data.Curry_FiniteMap.nd_C_addToFM (let s1 = leftSupply
                                                                   s2
                                                                 s0 = rightSupply
                                                                   s2
    in s1 `seq` (s0 `seq`
    Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    s0 cd cs) s1 cd cs)) x3 x2 Curry_Prelude.C_Nothing s3 cd cs)) s5 cd cs))
  Curry_Prelude.C_Just x5 -> let s0 = s
    in s0 `seq` nd_C_sourceDeps (d_C__case_12 x1 cd cs) x2 x5 x3 s0 cd cs
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i
    (nd_OP_moduleDeps_dot_uscore_hash_lambda21 x1 x2 x3 l s cd cs)
    (nd_OP_moduleDeps_dot_uscore_hash_lambda21 x1 x2 x3 r s cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z ->
    nd_OP_moduleDeps_dot_uscore_hash_lambda21 x1 x2 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c
    (nd_OP_moduleDeps_dot_uscore_hash_lambda21 x1 x2 x3 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "ModuleDeps.moduleDeps._#lambda21" [show x1, show x2, show x3, show x4]
    info)
  _ -> failCons cd (consFail "ModuleDeps.moduleDeps._#lambda21" (showCons x4))

d_C_lookupModule :: Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_lookupModule x1 x2 cd cs = let x3 = Curry_Prelude.OP_Cons
                                     (Curry_Prelude.toCurryString ".")
                                     (Curry_CompilerOpts.d_C_optImportPaths x1
                                     cd cs)
  in Curry_Files.d_C_lookupFileInPath (Curry_Prelude.d_C_apply
  (Curry_Names.d_C_moduleNameToPath cd cs) x2 cd cs) (Curry_Prelude.OP_Cons
  (Curry_Prelude.toCurryString ".curry") (Curry_Prelude.OP_Cons
  (Curry_Prelude.toCurryString ".lcurry") (Curry_Prelude.OP_Cons
  (Curry_Prelude.toCurryString ".tfcy") Curry_Prelude.OP_List)))
  (Curry_Prelude.d_C_map Curry_FilePath.d_C_dropTrailingPathSeparator x3 cd cs)
  cd cs

d_C_sourceDeps :: Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Data.Curry_FiniteMap.C_FM (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Data.Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))))
d_C_sourceDeps x1 x2 x3 x4 cd cs =
  Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_getTfcyFileName x1 x2 x3 cd cs) (d_OP_sourceDeps_dot_uscore_hash_lambda40
  x1 x3 x4) cd cs

nd_C_sourceDeps :: Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Data.Curry_FiniteMap.C_FM (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Data.Curry_FiniteMap.C_FM (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char))))
nd_C_sourceDeps x1 x2 x3 x4 s cd cs = let s0 = s
  in s0 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_getTfcyFileName x1 x2 x3 cd cs) (wrapNX id
  (nd_OP_sourceDeps_dot_uscore_hash_lambda40 x1 x3 x4)) s0 cd cs

d_OP_sourceDeps_dot_uscore_hash_lambda40 :: Curry_CompilerOpts.C_Options
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Data.Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Data.Curry_FiniteMap.C_FM (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char))))
d_OP_sourceDeps_dot_uscore_hash_lambda40 x1 x2 x3 x4 cd cs = let x5 = x4
  in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_readTfcyModuleHeader x5 cd cs)
  (d_OP_sourceDeps_dot_uscore_hash_lambda40_dot_uscore_hash_lambda42 x1 x2 x5
  x3) cd cs

nd_OP_sourceDeps_dot_uscore_hash_lambda40 :: Curry_CompilerOpts.C_Options
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Data.Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Data.Curry_FiniteMap.C_FM (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char))))
nd_OP_sourceDeps_dot_uscore_hash_lambda40 x1 x2 x3 x4 s cd cs = let s0 = s
  in s0 `seq` (let x5 = x4
  in Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_readTfcyModuleHeader x5 cd cs) (wrapNX id
  (nd_OP_sourceDeps_dot_uscore_hash_lambda40_dot_uscore_hash_lambda42 x1 x2 x5
  x3)) s0 cd cs)

d_OP_sourceDeps_dot_uscore_hash_lambda40_dot_uscore_hash_lambda42 :: Curry_CompilerOpts.C_Options
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Data.Curry_FiniteMap.C_FM (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Data.Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))))
d_OP_sourceDeps_dot_uscore_hash_lambda40_dot_uscore_hash_lambda42 x1 x2 x3 x4 x5 cd cs =
  let x6 = x5
      x7 = d_C_readModuleNameAndImports x6 cd cs
      x8 = d_OP_sourceDeps_dot_uscore_hash_lambda40_dot_uscore_hash_lambda42_dot_uscore_hash_selFP8_hash_m
        x7 cd cs
      x9 = d_OP_sourceDeps_dot_uscore_hash_lambda40_dot_uscore_hash_lambda42_dot_uscore_hash_selFP9_hash_is
        x7 cd cs
  in Curry_Prelude.d_C_foldIO (acceptCs id (d_C_moduleDeps x1))
  (Data.Curry_FiniteMap.d_C_addToFM
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char cd
  cs) cd cs) x4 x8 (Curry_Prelude.C_Just (Curry_Prelude.OP_Tuple3 x2 x9 x3)) cd
  cs) x9 cd cs

nd_OP_sourceDeps_dot_uscore_hash_lambda40_dot_uscore_hash_lambda42 :: Curry_CompilerOpts.C_Options
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Data.Curry_FiniteMap.C_FM (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Data.Curry_FiniteMap.C_FM (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char))))
nd_OP_sourceDeps_dot_uscore_hash_lambda40_dot_uscore_hash_lambda42 x1 x2 x3 x4 x5 s cd cs =
  let s6 = s
  in s6 `seq` (let x6 = x5
                   x7 = d_C_readModuleNameAndImports x6 cd cs
                   x8 = d_OP_sourceDeps_dot_uscore_hash_lambda40_dot_uscore_hash_lambda42_dot_uscore_hash_selFP8_hash_m
                     x7 cd cs
                   x9 = d_OP_sourceDeps_dot_uscore_hash_lambda40_dot_uscore_hash_lambda42_dot_uscore_hash_selFP9_hash_is
                     x7 cd cs
  in let s5 = leftSupply s6
         s4 = rightSupply s6
  in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_foldIO (wrapDX (wrapNX id) (acceptCs
  id (nd_C_moduleDeps x1))) (let s3 = leftSupply s4
                                 s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Data.Curry_FiniteMap.nd_C_addToFM (let s1 = leftSupply
                                                                 s2
                                                               s0 = rightSupply
                                                                 s2
  in s1 `seq` (s0 `seq`
  Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char s0
  cd cs) s1 cd cs)) x4 x8 (Curry_Prelude.C_Just (Curry_Prelude.OP_Tuple3 x2 x9
  x3)) s3 cd cs)) x9 s5 cd cs))

d_OP_sourceDeps_dot_uscore_hash_lambda40_dot_uscore_hash_lambda42_dot_uscore_hash_selFP8_hash_m :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_sourceDeps_dot_uscore_hash_lambda40_dot_uscore_hash_lambda42_dot_uscore_hash_selFP8_hash_m x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_sourceDeps_dot_uscore_hash_lambda40_dot_uscore_hash_lambda42_dot_uscore_hash_selFP8_hash_m
    l cd cs)
    (d_OP_sourceDeps_dot_uscore_hash_lambda40_dot_uscore_hash_lambda42_dot_uscore_hash_selFP8_hash_m
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_sourceDeps_dot_uscore_hash_lambda40_dot_uscore_hash_lambda42_dot_uscore_hash_selFP8_hash_m
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_sourceDeps_dot_uscore_hash_lambda40_dot_uscore_hash_lambda42_dot_uscore_hash_selFP8_hash_m
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps.sourceDeps._#lambda40._#lambda42._#selFP8#m" [show x1] info)
  _ -> failCons cd (consFail
    "ModuleDeps.sourceDeps._#lambda40._#lambda42._#selFP8#m" (showCons x1))

d_OP_sourceDeps_dot_uscore_hash_lambda40_dot_uscore_hash_lambda42_dot_uscore_hash_selFP9_hash_is :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_sourceDeps_dot_uscore_hash_lambda40_dot_uscore_hash_lambda42_dot_uscore_hash_selFP9_hash_is x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_sourceDeps_dot_uscore_hash_lambda40_dot_uscore_hash_lambda42_dot_uscore_hash_selFP9_hash_is
    l cd cs)
    (d_OP_sourceDeps_dot_uscore_hash_lambda40_dot_uscore_hash_lambda42_dot_uscore_hash_selFP9_hash_is
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_sourceDeps_dot_uscore_hash_lambda40_dot_uscore_hash_lambda42_dot_uscore_hash_selFP9_hash_is
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_sourceDeps_dot_uscore_hash_lambda40_dot_uscore_hash_lambda42_dot_uscore_hash_selFP9_hash_is
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps.sourceDeps._#lambda40._#lambda42._#selFP9#is" [show x1] info)
  _ -> failCons cd (consFail
    "ModuleDeps.sourceDeps._#lambda40._#lambda42._#selFP9#is" (showCons x1))

d_C_readModuleNameAndImports :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C_readModuleNameAndImports x1 cd cs = let x2 = Curry_Prelude.d_C_apply
                                              (Curry_Prelude.d_C_reads
                                              (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Read_hash_lbracket_rbracket
                                              (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Prelude_dot_Char
                                              cd cs) cd cs) cd cs) x1 cd cs
                                            x3 = d_OP_readModuleNameAndImports_dot_uscore_hash_selFP13_hash_m
                                              x2 cd cs
                                            x4 = d_OP_readModuleNameAndImports_dot_uscore_hash_selFP14_hash_s_tick
                                              x2 cd cs
                                            x5 = Curry_Prelude.d_C_apply
                                              (Curry_Prelude.d_C_reads
                                              (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Read_hash_lbracket_rbracket
                                              (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Read_hash_lbracket_rbracket
                                              (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Prelude_dot_Char
                                              cd cs) cd cs) cd cs) cd cs) x4 cd
                                              cs
                                            x6 = d_OP_readModuleNameAndImports_dot_uscore_hash_selFP12_hash_is
                                              x5 cd cs
  in Curry_Prelude.OP_Tuple2 x3 x6

d_OP_readModuleNameAndImports_dot_uscore_hash_selFP13_hash_m :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_readModuleNameAndImports_dot_uscore_hash_selFP13_hash_m x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Cons x2 x3 -> d_C__case_11 x2 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_readModuleNameAndImports_dot_uscore_hash_selFP13_hash_m l cd cs)
    (d_OP_readModuleNameAndImports_dot_uscore_hash_selFP13_hash_m r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_readModuleNameAndImports_dot_uscore_hash_selFP13_hash_m z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (d_OP_readModuleNameAndImports_dot_uscore_hash_selFP13_hash_m e cd $! addCs
    c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "ModuleDeps.readModuleNameAndImports._#selFP13#m" [show x1] info)
  _ -> failCons cd (consFail "ModuleDeps.readModuleNameAndImports._#selFP13#m"
    (showCons x1))

d_OP_readModuleNameAndImports_dot_uscore_hash_selFP14_hash_s_tick :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_readModuleNameAndImports_dot_uscore_hash_selFP14_hash_s_tick x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Cons x2 x3 -> d_C__case_10 x2 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_readModuleNameAndImports_dot_uscore_hash_selFP14_hash_s_tick l cd cs)
    (d_OP_readModuleNameAndImports_dot_uscore_hash_selFP14_hash_s_tick r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_readModuleNameAndImports_dot_uscore_hash_selFP14_hash_s_tick z cd cs)
    xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (d_OP_readModuleNameAndImports_dot_uscore_hash_selFP14_hash_s_tick e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "ModuleDeps.readModuleNameAndImports._#selFP14#s'" [show x1] info)
  _ -> failCons cd (consFail "ModuleDeps.readModuleNameAndImports._#selFP14#s'"
    (showCons x1))

d_OP_readModuleNameAndImports_dot_uscore_hash_selFP12_hash_is :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_readModuleNameAndImports_dot_uscore_hash_selFP12_hash_is x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Cons x2 x3 -> d_C__case_9 x2 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_readModuleNameAndImports_dot_uscore_hash_selFP12_hash_is l cd cs)
    (d_OP_readModuleNameAndImports_dot_uscore_hash_selFP12_hash_is r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_readModuleNameAndImports_dot_uscore_hash_selFP12_hash_is z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (d_OP_readModuleNameAndImports_dot_uscore_hash_selFP12_hash_is e cd $! addCs
    c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "ModuleDeps.readModuleNameAndImports._#selFP12#is" [show x1] info)
  _ -> failCons cd (consFail "ModuleDeps.readModuleNameAndImports._#selFP12#is"
    (showCons x1))

d_C_hReadUntil :: Curry_IO.C_Handle -> (Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_hReadUntil x1 x2 cd cs =
  Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_IO.d_C_hIsEOF x1 cd cs) (d_OP_hReadUntil_dot_uscore_hash_lambda45 x1
  x2) cd cs

nd_C_hReadUntil :: Curry_IO.C_Handle -> Func Curry_Prelude.C_Char
  Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
nd_C_hReadUntil x1 x2 s cd cs = let s0 = s
  in s0 `seq`
  Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_IO.d_C_hIsEOF x1 cd cs) (wrapNX id
  (nd_OP_hReadUntil_dot_uscore_hash_lambda45 x1 x2)) s0 cd cs

d_OP_hReadUntil_dot_uscore_hash_lambda45 :: Curry_IO.C_Handle
  -> (Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_Bool)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_hReadUntil_dot_uscore_hash_lambda45 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (Curry_IO.d_C_hClose x1 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    Curry_Prelude.OP_List cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (Curry_IO.d_C_hGetChar x1 cd cs)
    (d_OP_hReadUntil_dot_uscore_hash_lambda45_dot_uscore_hash_lambda48 x1 x2) cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i
    (d_OP_hReadUntil_dot_uscore_hash_lambda45 x1 x2 l cd cs)
    (d_OP_hReadUntil_dot_uscore_hash_lambda45 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    d_OP_hReadUntil_dot_uscore_hash_lambda45 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c
    (d_OP_hReadUntil_dot_uscore_hash_lambda45 x1 x2 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "ModuleDeps.hReadUntil._#lambda45" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "ModuleDeps.hReadUntil._#lambda45" (showCons x3))

nd_OP_hReadUntil_dot_uscore_hash_lambda45 :: Curry_IO.C_Handle -> Func
  Curry_Prelude.C_Char Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
nd_OP_hReadUntil_dot_uscore_hash_lambda45 x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (Curry_IO.d_C_hClose x1 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    Curry_Prelude.OP_List cd cs) s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (Curry_IO.d_C_hGetChar x1 cd cs) (wrapNX id
    (nd_OP_hReadUntil_dot_uscore_hash_lambda45_dot_uscore_hash_lambda48 x1 x2))
    s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i
    (nd_OP_hReadUntil_dot_uscore_hash_lambda45 x1 x2 l s cd cs)
    (nd_OP_hReadUntil_dot_uscore_hash_lambda45 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    nd_OP_hReadUntil_dot_uscore_hash_lambda45 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c
    (nd_OP_hReadUntil_dot_uscore_hash_lambda45 x1 x2 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "ModuleDeps.hReadUntil._#lambda45" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "ModuleDeps.hReadUntil._#lambda45" (showCons x3))

d_OP_hReadUntil_dot_uscore_hash_lambda45_dot_uscore_hash_lambda48 :: Curry_IO.C_Handle
  -> (Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_Bool)
  -> Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_hReadUntil_dot_uscore_hash_lambda45_dot_uscore_hash_lambda48 x1 x2 x3 cd cs =
  let x4 = x3
  in d_C__case_8 x4 x2 x1 (Curry_Prelude.d_C_apply x2 x4 cd cs) cd cs

nd_OP_hReadUntil_dot_uscore_hash_lambda45_dot_uscore_hash_lambda48 :: Curry_IO.C_Handle
  -> Func Curry_Prelude.C_Char Curry_Prelude.C_Bool -> Curry_Prelude.C_Char
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
nd_OP_hReadUntil_dot_uscore_hash_lambda45_dot_uscore_hash_lambda48 x1 x2 x3 s cd cs =
  let s2 = s
  in s2 `seq` (let x4 = x3
  in let s1 = leftSupply s2
         s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C__case_8 x4 x2 x1 (Curry_Prelude.nd_C_apply x2 x4 s0
  cd cs) s1 cd cs))

d_OP_hReadUntil_dot_uscore_hash_lambda45_dot_uscore_hash_lambda48_dot_uscore_hash_lambda51 :: Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_hReadUntil_dot_uscore_hash_lambda45_dot_uscore_hash_lambda48_dot_uscore_hash_lambda51 x1 x2 cd cs =
  let x3 = x2
  in Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Prelude.OP_Cons x1 x3) cd cs

d_C_readTfcyModuleHeader :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C_readTfcyModuleHeader x1 cd cs =
  Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_IO.d_C_openFile x1 Curry_IO.C_ReadMode cd cs)
  d_OP_readTfcyModuleHeader_dot_uscore_hash_lambda56 cd cs

d_OP_readTfcyModuleHeader_dot_uscore_hash_lambda56 :: Curry_IO.C_Handle -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_readTfcyModuleHeader_dot_uscore_hash_lambda56 x1 cd cs = let x2 = x1
  in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Prelude.d_OP_dollar (d_C_hReadUntil x2) (Curry_Prelude.d_OP_dot
  Curry_Prelude.d_C_not Curry_Char.d_C_isSpace cd cs) cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_hReadUntil x2 Curry_Char.d_C_isSpace cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Prelude.d_OP_dollar (d_C_hReadUntil x2) (Curry_Prelude.d_OP_dot
  Curry_Prelude.d_C_not Curry_Char.d_C_isSpace cd cs) cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Prelude.d_OP_dollar (d_C_hReadUntil x2) Curry_Char.d_C_isSpace cd cs)
  (d_OP_readTfcyModuleHeader_dot_uscore_hash_lambda56_dot_uscore_hash_lambda58
  x2) cd cs) cd cs) cd cs) cd cs

d_OP_readTfcyModuleHeader_dot_uscore_hash_lambda56_dot_uscore_hash_lambda58 :: Curry_IO.C_Handle
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_readTfcyModuleHeader_dot_uscore_hash_lambda56_dot_uscore_hash_lambda58 x1 x2 cd cs =
  let x3 = x2
  in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_hReadUntil x1 (Curry_Prelude.d_C_flip (acceptCs id
  Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char)
  (Curry_Prelude.C_Char '['#)) cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_hReadUntil x1 (Curry_Prelude.d_C_flip (acceptCs id
  Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char)
  (Curry_Prelude.C_Char ']'#)) cd cs)
  (d_OP_readTfcyModuleHeader_dot_uscore_hash_lambda56_dot_uscore_hash_lambda58_dot_uscore_hash_lambda60
  x1 x3) cd cs) cd cs

d_OP_readTfcyModuleHeader_dot_uscore_hash_lambda56_dot_uscore_hash_lambda58_dot_uscore_hash_lambda60 :: Curry_IO.C_Handle
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_readTfcyModuleHeader_dot_uscore_hash_lambda56_dot_uscore_hash_lambda58_dot_uscore_hash_lambda60 x1 x2 x3 cd cs =
  let x4 = x3
  in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_IO.d_C_hClose x1 cd cs) (Curry_Prelude.d_OP_dollar
  Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '"'#)
  (Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "[") x4 cd cs) cd cs)) cd cs) cd cs

d_C_getTfcyFileName :: Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C_getTfcyFileName x1 x2 x3 cd cs = let x4 = Curry_Prelude.OP_Cons
                                           (Curry_Prelude.toCurryString ".")
                                           (Curry_CompilerOpts.d_C_optImportPaths
                                           x1 cd cs)
                                         x5 = Curry_Prelude.d_OP_plus_plus
                                           (Curry_Prelude.toCurryString "__")
                                           (Curry_Prelude.d_OP_plus_plus
                                           (Curry_Prelude.d_C_map
                                           Curry_Char.d_C_toUpper
                                           (Curry_Installation.d_C_compilerName
                                           cd cs) cd cs)
                                           (Curry_Prelude.toCurryString "__") cd
                                           cs) cd cs
                                         x6 = Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int
                                           (Curry_Prelude.d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Prelude_dot_Int
                                           (Curry_Installation.d_C_majorVersion
                                           cd cs) (Curry_Prelude.C_Int (100)) cd
                                           cs)
                                           (Curry_Installation.d_C_minorVersion
                                           cd cs) cd cs
  in d_C__case_7 x3 x1 x4 x6 x5 x2 (d_C_isTypedFlatCurryFile x3 cd cs) cd cs

d_OP_getTfcyFileName_dot_uscore_hash_lambda63 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_getTfcyFileName_dot_uscore_hash_lambda63 x1 cd cs = let x2 = x1
  in Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  x2 cd cs

d_C_parseCurryWithOptions :: Curry_CompilerOpts.C_Options
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> System.Curry_FrontendExec.C_FrontendParams -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_parseCurryWithOptions x1 x2 x3 cd cs = let x4 = Curry_Prelude.OP_Cons
                                                 (Curry_Prelude.toCurryString
                                                 ".")
                                                 (Curry_CompilerOpts.d_C_optImportPaths
                                                 x1 cd cs)
  in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (d_C_lookupModule x1 x2 cd cs)
  (d_OP_parseCurryWithOptions_dot_uscore_hash_lambda66 x3 x2 x4) cd cs

d_OP_parseCurryWithOptions_dot_uscore_hash_lambda66 :: System.Curry_FrontendExec.C_FrontendParams
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_parseCurryWithOptions_dot_uscore_hash_lambda66 x1 x2 x3 x4 cd cs =
  let x5 = x4
  in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  (Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_unless
  (Curry_Maybe.d_C_isNothing x5 cd cs))
  (System.Curry_FrontendExec.d_C_callFrontendWithParams
  System.Curry_FrontendExec.C_TFCY x1 x2 cd cs) cd cs)
  (Curry_Prelude.d_OP_dollar (Curry_Prelude.d_C_liftIO
  Curry_FilePath.d_C_normalise) (Curry_Files.d_C_getFileInPath
  (FlatCurry.Annotated.Curry_Files.d_C_typedFlatCurryFileName x2 cd cs)
  (Curry_Prelude.OP_Cons Curry_Prelude.OP_List Curry_Prelude.OP_List)
  (Curry_Prelude.d_C_map Curry_FilePath.d_C_dropTrailingPathSeparator x3 cd cs)
  cd cs) cd cs) cd cs

d_C_isTypedFlatCurryFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C_isTypedFlatCurryFile x1 cd cs =
  Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char cd
  cs) (Curry_Prelude.d_C_apply (Curry_FilePath.d_C_takeExtension cd cs) x1 cd
  cs) (Curry_Prelude.toCurryString ".tfcy") cd cs

d_C_filterMissing :: Data.Curry_FiniteMap.C_FM (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char))))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_filterMissing x1 cd cs = let x2 = Curry_Prelude.d_OP_dollar
                                   (Curry_List.d_C_partition
                                   (Curry_Prelude.d_OP_dot
                                   Curry_Maybe.d_C_isJust Curry_Prelude.d_C_snd
                                   cd cs)) (Data.Curry_FiniteMap.d_C_fmToList x1
                                   cd cs) cd cs
                                 x3 = d_OP_filterMissing_dot_uscore_hash_selFP16_hash_present
                                   x2 cd cs
                                 x4 = d_OP_filterMissing_dot_uscore_hash_selFP17_hash_missing
                                   x2 cd cs
                                 x5 = Curry_Prelude.d_C_map
                                   d_OP_filterMissing_dot_uscore_hash_lambda68
                                   x4 cd cs
  in Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_C_map (Curry_Function.d_C_second
  Curry_Maybe.d_C_fromJust) x3 cd cs) x5

nd_C_filterMissing :: Data.Curry_FiniteMap.C_FM (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)))) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
nd_C_filterMissing x1 s cd cs = let s7 = s
  in s7 `seq` (let s3 = leftSupply s7
                   s8 = rightSupply s7
                   s5 = leftSupply s8
                   s6 = rightSupply s8
  in s3 `seq` (s8 `seq` (s5 `seq` (s6 `seq` (let x2 = let s2 = leftSupply s3
                                                          s4 = rightSupply s3
                                                          s0 = leftSupply s4
                                                          s1 = rightSupply s4
                                                   in s2 `seq` (s4 `seq`
                                                   (s0 `seq` (s1 `seq`
                                                   Curry_Prelude.nd_OP_dollar
                                                   (wrapNX id
                                                   (Curry_List.nd_C_partition
                                                   (Curry_Prelude.nd_OP_dot
                                                   (wrapDX id
                                                   Curry_Maybe.d_C_isJust)
                                                   (wrapDX id
                                                   Curry_Prelude.d_C_snd) s0 cd
                                                   cs)))
                                                   (Data.Curry_FiniteMap.nd_C_fmToList
                                                   x1 s1 cd cs) s2 cd cs)))
                                                 x3 = d_OP_filterMissing_dot_uscore_hash_selFP16_hash_present
                                                   x2 cd cs
                                                 x4 = d_OP_filterMissing_dot_uscore_hash_selFP17_hash_missing
                                                   x2 cd cs
                                                 x5 = Curry_Prelude.nd_C_map
                                                   (wrapDX id
                                                   d_OP_filterMissing_dot_uscore_hash_lambda68)
                                                   x4 s5 cd cs
  in Curry_Prelude.OP_Tuple2 (Curry_Prelude.nd_C_map (wrapNX id
  (Curry_Function.nd_C_second (wrapDX id Curry_Maybe.d_C_fromJust))) x3 s6 cd
  cs) x5)))))

d_OP_filterMissing_dot_uscore_hash_selFP16_hash_present :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))))) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))))) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))))
d_OP_filterMissing_dot_uscore_hash_selFP16_hash_present x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_filterMissing_dot_uscore_hash_selFP16_hash_present l cd cs)
    (d_OP_filterMissing_dot_uscore_hash_selFP16_hash_present r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_filterMissing_dot_uscore_hash_selFP16_hash_present z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_filterMissing_dot_uscore_hash_selFP16_hash_present e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps.filterMissing._#selFP16#present" [show x1] info)
  _ -> failCons cd (consFail "ModuleDeps.filterMissing._#selFP16#present"
    (showCons x1))

d_OP_filterMissing_dot_uscore_hash_selFP17_hash_missing :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))))) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))))) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))))
d_OP_filterMissing_dot_uscore_hash_selFP17_hash_missing x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_filterMissing_dot_uscore_hash_selFP17_hash_missing l cd cs)
    (d_OP_filterMissing_dot_uscore_hash_selFP17_hash_missing r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_filterMissing_dot_uscore_hash_selFP17_hash_missing z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_filterMissing_dot_uscore_hash_selFP17_hash_missing e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps.filterMissing._#selFP17#missing" [show x1] info)
  _ -> failCons cd (consFail "ModuleDeps.filterMissing._#selFP17#missing"
    (showCons x1))

d_OP_filterMissing_dot_uscore_hash_lambda68 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_filterMissing_dot_uscore_hash_lambda68 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "Module ") (Curry_Prelude.d_OP_plus_plus x2
    (Curry_Prelude.toCurryString " could not be found") cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_filterMissing_dot_uscore_hash_lambda68 l cd cs)
    (d_OP_filterMissing_dot_uscore_hash_lambda68 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_filterMissing_dot_uscore_hash_lambda68 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_filterMissing_dot_uscore_hash_lambda68 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps.filterMissing._#lambda68" [show x1] info)
  _ -> failCons cd (consFail "ModuleDeps.filterMissing._#lambda68" (showCons
    x1))

d_C_flattenDeps :: Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple3
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)))) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C_flattenDeps cd cs = let x1 = Data.Curry_SCC.d_C_scc
                              (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen
                              (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
                              (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
                              cd cs) cd cs)
                              (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_comma_rparen
                              (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
                              (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
                              cd cs) cd cs)
                              (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
                              (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
                              (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
                              cd cs) cd cs) cd cs)
                              (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
                              (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
                              cd cs) cd cs) cd cs) cd cs)
                              (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
                              (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
                              cd cs) cd cs) d_OP_flattenDeps_dot_modules_dot_74
                              d_OP_flattenDeps_dot_imports_dot_74 cd cs
                            x2 = Curry_Prelude.d_C_foldr (acceptCs id
                              d_OP_flattenDeps_dot_checkdep_dot_73)
                              (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_List
                              Curry_Prelude.OP_List)
  in Curry_Prelude.d_OP_dot x2 x1 cd cs

d_OP_flattenDeps_dot_modules_dot_74 :: forall t1 t0 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => Curry_Prelude.OP_Tuple2 t0 t1 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
d_OP_flattenDeps_dot_modules_dot_74 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_Prelude.OP_Cons x2
    Curry_Prelude.OP_List
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_flattenDeps_dot_modules_dot_74 l cd cs)
    (d_OP_flattenDeps_dot_modules_dot_74 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_flattenDeps_dot_modules_dot_74 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_flattenDeps_dot_modules_dot_74 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps.flattenDeps.modules.74" [show x1] info)
  _ -> failCons cd (consFail "ModuleDeps.flattenDeps.modules.74" (showCons x1))

d_OP_flattenDeps_dot_imports_dot_74 :: forall t0 t1 t3 t2 . (Curry_Prelude.Curry
  t2, Curry_Prelude.Curry t3, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple3 t1 t2 t3) -> Cover
  -> ConstStore -> t2
d_OP_flattenDeps_dot_imports_dot_74 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_5 x3 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_flattenDeps_dot_imports_dot_74 l cd cs)
    (d_OP_flattenDeps_dot_imports_dot_74 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_flattenDeps_dot_imports_dot_74 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_flattenDeps_dot_imports_dot_74 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps.flattenDeps.imports.74" [show x1] info)
  _ -> failCons cd (consFail "ModuleDeps.flattenDeps.imports.74" (showCons x1))

d_OP_flattenDeps_dot_cyclicError_dot_73 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_flattenDeps_dot_cyclicError_dot_73 x1 cd cs =
  let x2 = d_OP_flattenDeps_dot_cyclicError_dot_73_dot_splitLast_dot_94 x1 cd cs
      x3 = d_OP_flattenDeps_dot_cyclicError_dot_73_dot_uscore_hash_selFP22_hash_inits
        x2 cd cs
      x4 = d_OP_flattenDeps_dot_cyclicError_dot_73_dot_uscore_hash_selFP23_hash_last
        x2 cd cs
  in Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
  "Cylic import dependency between modules ") (Curry_Prelude.d_OP_plus_plus
  (Curry_List.d_C_intercalate (Curry_Prelude.toCurryString ", ") x3 cd cs)
  (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " and ") x4 cd cs)
  cd cs) cd cs

d_OP_flattenDeps_dot_cyclicError_dot_73_dot_splitLast_dot_94 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) t0
d_OP_flattenDeps_dot_cyclicError_dot_73_dot_splitLast_dot_94 x1 cd cs =
  case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "ModuleDeps.splitLast: empty list") cd cs
  Curry_Prelude.OP_Cons x2 x3 -> d_C__case_4 x2 x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_flattenDeps_dot_cyclicError_dot_73_dot_splitLast_dot_94 l cd cs)
    (d_OP_flattenDeps_dot_cyclicError_dot_73_dot_splitLast_dot_94 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_flattenDeps_dot_cyclicError_dot_73_dot_splitLast_dot_94 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (d_OP_flattenDeps_dot_cyclicError_dot_73_dot_splitLast_dot_94 e cd $! addCs
    c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "ModuleDeps.flattenDeps.cyclicError.73.splitLast.94" [show x1] info)
  _ -> failCons cd (consFail
    "ModuleDeps.flattenDeps.cyclicError.73.splitLast.94" (showCons x1))

d_OP_flattenDeps_dot_cyclicError_dot_73_dot_splitLast_dot_94_dot_uscore_hash_selFP20_hash_xs :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
d_OP_flattenDeps_dot_cyclicError_dot_73_dot_splitLast_dot_94_dot_uscore_hash_selFP20_hash_xs x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_flattenDeps_dot_cyclicError_dot_73_dot_splitLast_dot_94_dot_uscore_hash_selFP20_hash_xs
    l cd cs)
    (d_OP_flattenDeps_dot_cyclicError_dot_73_dot_splitLast_dot_94_dot_uscore_hash_selFP20_hash_xs
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_flattenDeps_dot_cyclicError_dot_73_dot_splitLast_dot_94_dot_uscore_hash_selFP20_hash_xs
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_flattenDeps_dot_cyclicError_dot_73_dot_splitLast_dot_94_dot_uscore_hash_selFP20_hash_xs
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps.flattenDeps.cyclicError.73.splitLast.94._#selFP20#xs" [show x1]
    info)
  _ -> failCons cd (consFail
    "ModuleDeps.flattenDeps.cyclicError.73.splitLast.94._#selFP20#xs" (showCons
    x1))

d_OP_flattenDeps_dot_cyclicError_dot_73_dot_splitLast_dot_94_dot_uscore_hash_selFP21_hash_z :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) t0 -> Cover
  -> ConstStore -> t0
d_OP_flattenDeps_dot_cyclicError_dot_73_dot_splitLast_dot_94_dot_uscore_hash_selFP21_hash_z x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_flattenDeps_dot_cyclicError_dot_73_dot_splitLast_dot_94_dot_uscore_hash_selFP21_hash_z
    l cd cs)
    (d_OP_flattenDeps_dot_cyclicError_dot_73_dot_splitLast_dot_94_dot_uscore_hash_selFP21_hash_z
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_flattenDeps_dot_cyclicError_dot_73_dot_splitLast_dot_94_dot_uscore_hash_selFP21_hash_z
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_flattenDeps_dot_cyclicError_dot_73_dot_splitLast_dot_94_dot_uscore_hash_selFP21_hash_z
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps.flattenDeps.cyclicError.73.splitLast.94._#selFP21#z" [show x1]
    info)
  _ -> failCons cd (consFail
    "ModuleDeps.flattenDeps.cyclicError.73.splitLast.94._#selFP21#z" (showCons
    x1))

d_OP_flattenDeps_dot_cyclicError_dot_73_dot_uscore_hash_selFP22_hash_inits :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_flattenDeps_dot_cyclicError_dot_73_dot_uscore_hash_selFP22_hash_inits x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_flattenDeps_dot_cyclicError_dot_73_dot_uscore_hash_selFP22_hash_inits
    l cd cs)
    (d_OP_flattenDeps_dot_cyclicError_dot_73_dot_uscore_hash_selFP22_hash_inits
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_flattenDeps_dot_cyclicError_dot_73_dot_uscore_hash_selFP22_hash_inits z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_flattenDeps_dot_cyclicError_dot_73_dot_uscore_hash_selFP22_hash_inits
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps.flattenDeps.cyclicError.73._#selFP22#inits" [show x1] info)
  _ -> failCons cd (consFail
    "ModuleDeps.flattenDeps.cyclicError.73._#selFP22#inits" (showCons x1))

d_OP_flattenDeps_dot_cyclicError_dot_73_dot_uscore_hash_selFP23_hash_last :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_flattenDeps_dot_cyclicError_dot_73_dot_uscore_hash_selFP23_hash_last x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_flattenDeps_dot_cyclicError_dot_73_dot_uscore_hash_selFP23_hash_last l
    cd cs)
    (d_OP_flattenDeps_dot_cyclicError_dot_73_dot_uscore_hash_selFP23_hash_last r
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_flattenDeps_dot_cyclicError_dot_73_dot_uscore_hash_selFP23_hash_last z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_flattenDeps_dot_cyclicError_dot_73_dot_uscore_hash_selFP23_hash_last e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps.flattenDeps.cyclicError.73._#selFP23#last" [show x1] info)
  _ -> failCons cd (consFail
    "ModuleDeps.flattenDeps.cyclicError.73._#selFP23#last" (showCons x1))

d_OP_flattenDeps_dot_checkdep_dot_73 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) t0) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_flattenDeps_dot_checkdep_dot_73 x1 x2 cd cs = case x1 of
  Curry_Prelude.OP_List -> d_C__case_3 x2 cd cs
  Curry_Prelude.OP_Cons x5 x6 -> d_C__case_2 x2 x1 x5 x6 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_flattenDeps_dot_checkdep_dot_73 l x2 cd cs)
    (d_OP_flattenDeps_dot_checkdep_dot_73 r x2 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_flattenDeps_dot_checkdep_dot_73 z x2 cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (d_OP_flattenDeps_dot_checkdep_dot_73 e x2 cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "ModuleDeps.flattenDeps.checkdep.73" [show x1, show x2] info)
  _ -> failCons cd (consFail "ModuleDeps.flattenDeps.checkdep.73" (showCons x1))

d_C__case_2 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) t0)) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0 -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0)
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_2 x2 x1 x5 x6 cd cs = case x6 of
  Curry_Prelude.OP_List -> d_C__case_1 x5 x2 cd cs
  Curry_Prelude.OP_Cons x9 x10 -> d_C__case_0 x1 x2 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_2 x2 x1 x5 l cd
    cs) (d_C__case_2 x2 x1 x5 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_2 x2
    x1 x5 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_2 x2 x1 x5 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "ModuleDeps._case_2" [show x2, show x1, show x5, show x6] info)
  _ -> failCons cd (consFail "ModuleDeps._case_2" (showCons x6))

d_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0)
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0)) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0)) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_0 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x11 x12 -> Curry_Prelude.OP_Tuple2 x11
    (Curry_Prelude.OP_Cons (d_OP_flattenDeps_dot_cyclicError_dot_73
    (Curry_Prelude.d_C_map Curry_Prelude.d_C_fst x1 cd cs) cd cs) x12)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_0 x1 l cd cs)
    (d_C__case_0 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_0 x1
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_0 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps._case_0" [show x1, show x2] info)
  _ -> failCons cd (consFail "ModuleDeps._case_0" (showCons x2))

d_C__case_1 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) t0 -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) t0)) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) t0)) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C__case_1 x5 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x7 x8 -> Curry_Prelude.OP_Tuple2
    (Curry_Prelude.OP_Cons x5 x7) x8
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_1 x5 l cd cs)
    (d_C__case_1 x5 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_1 x5
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_1 x5 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps._case_1" [show x5, show x2] info)
  _ -> failCons cd (consFail "ModuleDeps._case_1" (showCons x2))

d_C__case_3 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) t0)) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) t0)) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C__case_3 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.OP_Tuple2 x3 x4
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_3 l cd cs)
    (d_C__case_3 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_3 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_3 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps._case_3" [show x2] info)
  _ -> failCons cd (consFail "ModuleDeps._case_3" (showCons x2))

d_C__case_4 :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) t0
d_C__case_4 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_List x2
  Curry_Prelude.OP_Cons x4 x5 -> let x6 = d_OP_flattenDeps_dot_cyclicError_dot_73_dot_splitLast_dot_94
                                       (Curry_Prelude.OP_Cons x4 x5) cd cs
                                     x7 = d_OP_flattenDeps_dot_cyclicError_dot_73_dot_splitLast_dot_94_dot_uscore_hash_selFP20_hash_xs
                                       x6 cd cs
                                     x8 = d_OP_flattenDeps_dot_cyclicError_dot_73_dot_splitLast_dot_94_dot_uscore_hash_selFP21_hash_z
                                       x6 cd cs
    in Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Cons x2 x7) x8
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_4 x2 l cd cs)
    (d_C__case_4 x2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_4 x2 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_4 x2 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "ModuleDeps._case_4" [show x2, show x3] info)
  _ -> failCons cd (consFail "ModuleDeps._case_4" (showCons x3))

d_C__case_5 :: forall t1 t3 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t1) => Curry_Prelude.OP_Tuple3 t1 t2 t3 -> Cover
  -> ConstStore -> t2
d_C__case_5 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple3 x4 x5 x6 -> x5
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i (d_C__case_5 l cd cs)
    (d_C__case_5 r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z -> d_C__case_5 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c (d_C__case_5 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "ModuleDeps._case_5" [show x3] info)
  _ -> failCons cd (consFail "ModuleDeps._case_5" (showCons x3))

d_C__case_7 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_7 x3 x1 x4 x6 x5 x2 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (Curry_Prelude.d_OP_dollar (Curry_Message.d_C_showStatus x1)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    "Reading directly from typed FlatCurry file '")
    (Curry_Prelude.d_OP_plus_plus x3 (Curry_Prelude.toCurryString "'") cd cs) cd
    cs) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    x3 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_6 x1 x4 x6 x5 x2
    (Curry_Prelude.d_C_otherwise cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_7 x3 x1 x4 x6 x5
    x2 l cd cs) (d_C__case_7 x3 x1 x4 x6 x5 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_7 x3 x1
    x4 x6 x5 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_7 x3 x1 x4 x6 x5
    x2 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "ModuleDeps._case_7"
    [show x3, show x1, show x4, show x6, show x5, show x2, show x7] info)
  _ -> failCons cd (consFail "ModuleDeps._case_7" (showCons x7))

d_C__case_6 :: Curry_CompilerOpts.C_Options -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_6 x1 x4 x6 x5 x2 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (Curry_Prelude.d_OP_dollar (d_C_parseCurryWithOptions x1
    (System.Curry_CurryPath.d_C_stripCurrySuffix x2 cd cs))
    (Curry_Prelude.d_OP_dollar (System.Curry_FrontendExec.d_C_setDefinitions
    (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 x5 x6)
    Curry_Prelude.OP_List)) (Curry_Prelude.d_OP_dollar
    (System.Curry_FrontendExec.d_C_setFullPath x4) (Curry_Prelude.d_OP_dollar
    (System.Curry_FrontendExec.d_C_setQuiet
    (Curry_CompilerOpts.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_CompilerOpts_dot_Verbosity
    (Curry_CompilerOpts.d_C_optVerbosity x1 cd cs)
    Curry_CompilerOpts.C_VerbQuiet cd cs))
    (System.Curry_FrontendExec.d_C_setSpecials (Curry_CompilerOpts.d_C_optParser
    x1 cd cs) (System.Curry_FrontendExec.d_C_defaultParams cd cs) cd cs) cd cs)
    cd cs) cd cs) cd cs) d_OP_getTfcyFileName_dot_uscore_hash_lambda63 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_6 x1 x4 x6 x5 x2
    l cd cs) (d_C__case_6 x1 x4 x6 x5 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_6 x1 x4
    x6 x5 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_6 x1 x4 x6 x5 x2
    e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "ModuleDeps._case_6"
    [show x1, show x4, show x6, show x5, show x2, show x7] info)
  _ -> failCons cd (consFail "ModuleDeps._case_6" (showCons x7))

d_C__case_8 :: Curry_Prelude.C_Char -> (Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool) -> Curry_IO.C_Handle
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_8 x4 x2 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (Curry_Prelude.OP_Cons x4 Curry_Prelude.OP_List) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (d_C_hReadUntil x1 x2 cd cs)
    (d_OP_hReadUntil_dot_uscore_hash_lambda45_dot_uscore_hash_lambda48_dot_uscore_hash_lambda51
    x4) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_8 x4 x2 x1 l cd
    cs) (d_C__case_8 x4 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_8 x4 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_8 x4 x2 x1 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "ModuleDeps._case_8"
    [show x4, show x2, show x1, show x5] info)
  _ -> failCons cd (consFail "ModuleDeps._case_8" (showCons x5))

nd_C__case_8 :: Curry_Prelude.C_Char -> Func Curry_Prelude.C_Char
  Curry_Prelude.C_Bool -> Curry_IO.C_Handle -> Curry_Prelude.C_Bool -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
nd_C__case_8 x4 x2 x1 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (Curry_Prelude.OP_Cons x4 Curry_Prelude.OP_List) cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (nd_C_hReadUntil x1 x2 s0 cd cs) (wrapDX id
    (d_OP_hReadUntil_dot_uscore_hash_lambda45_dot_uscore_hash_lambda48_dot_uscore_hash_lambda51
    x4)) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_8 x4 x2 x1 l s
    cd cs) (nd_C__case_8 x4 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_8 x4
    x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_8 x4 x2 x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "ModuleDeps._case_8"
    [show x4, show x2, show x1, show x5] info)
  _ -> failCons cd (consFail "ModuleDeps._case_8" (showCons x5))

d_C__case_9 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_9 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> x4
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_9 l cd cs)
    (d_C__case_9 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_9 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_9 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps._case_9" [show x2] info)
  _ -> failCons cd (consFail "ModuleDeps._case_9" (showCons x2))

d_C__case_10 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_10 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> x5
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_10 l cd cs)
    (d_C__case_10 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_10 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_10 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps._case_10" [show x2] info)
  _ -> failCons cd (consFail "ModuleDeps._case_10" (showCons x2))

d_C__case_11 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_11 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> x4
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_11 l cd cs)
    (d_C__case_11 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_11 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_11 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "ModuleDeps._case_11" [show x2] info)
  _ -> failCons cd (consFail "ModuleDeps._case_11" (showCons x2))

d_C__case_12 :: Curry_CompilerOpts.C_Options -> Cover -> ConstStore
  -> Curry_CompilerOpts.C_Options
d_C__case_12 x1 cd cs = case x1 of
  Curry_CompilerOpts.C_Opts x6 x7 x8 x9 x10 x11 x12 x13 x14 x15 x16 x17 x18 -> Curry_CompilerOpts.C_Opts
    x6 x7 Curry_CompilerOpts.C_VerbQuiet x9 x10 x11 x12 x13 x14 x15 x16 x17 x18
  Curry_CompilerOpts.Choice_C_Options d i l r -> narrow d i (d_C__case_12 l cd
    cs) (d_C__case_12 r cd cs)
  Curry_CompilerOpts.Choices_C_Options d i xs -> narrows cs d i (\z ->
    d_C__case_12 z cd cs) xs
  Curry_CompilerOpts.Guard_C_Options d c e -> guardCons d c (d_C__case_12 e
    cd $! addCs c cs)
  Curry_CompilerOpts.Fail_C_Options d info -> failCons d (traceFail
    "ModuleDeps._case_12" [show x1] info)
  _ -> failCons cd (consFail "ModuleDeps._case_12" (showCons x1))

d_C__case_13 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Data.Curry_FiniteMap.C_FM (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  -> Curry_CompilerOpts.C_Options -> Curry_Prelude.C_Maybe
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char))) -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Data.Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))))
d_C__case_13 x3 x2 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_Just x4 -> Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    x2 cd cs
  Curry_Prelude.C_Nothing -> Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (d_C_lookupModule x1 x3 cd cs) (d_OP_moduleDeps_dot_uscore_hash_lambda21 x1
    x3 x2) cd cs
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i (d_C__case_13 x3 x2 x1 l cd
    cs) (d_C__case_13 x3 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z -> d_C__case_13 x3
    x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c (d_C__case_13 x3 x2 x1 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "ModuleDeps._case_13" [show x3, show x2, show x1, show x5] info)
  _ -> failCons cd (consFail "ModuleDeps._case_13" (showCons x5))

nd_C__case_13 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Data.Curry_FiniteMap.C_FM (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  -> Curry_CompilerOpts.C_Options -> Curry_Prelude.C_Maybe
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Data.Curry_FiniteMap.C_FM (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple3 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List Curry_Prelude.C_Char))))
nd_C__case_13 x3 x2 x1 x5 s cd cs = case x5 of
  Curry_Prelude.C_Just x4 -> Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    x2 cd cs
  Curry_Prelude.C_Nothing -> let s0 = s
    in s0 `seq`
    Curry_Prelude.nd_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (d_C_lookupModule x1 x3 cd cs) (wrapNX id
    (nd_OP_moduleDeps_dot_uscore_hash_lambda21 x1 x3 x2)) s0 cd cs
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i (nd_C__case_13 x3 x2 x1 l s
    cd cs) (nd_C__case_13 x3 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z -> nd_C__case_13 x3
    x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c (nd_C__case_13 x3 x2 x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "ModuleDeps._case_13" [show x3, show x2, show x1, show x5] info)
  _ -> failCons cd (consFail "ModuleDeps._case_13" (showCons x5))

d_C__case_14 :: Curry_Time.C_ClockTime -> Curry_Time.C_ClockTime
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_14 x1 x5 x2 x3 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "Typed FlatCurry file ")
    (Curry_Prelude.d_OP_plus_plus x3 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " is older than Curry file ") x2 cd cs) cd cs)
    cd cs) Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_14 x1 x5 x2 x3 l
    cd cs) (d_C__case_14 x1 x5 x2 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_14 x1
    x5 x2 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_14 x1 x5 x2 x3 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "ModuleDeps._case_14" [show x1, show x5, show x2, show x3, show x6] info)
  _ -> failCons cd (consFail "ModuleDeps._case_14" (showCons x6))

d_C__case_17 :: Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C__case_17 x5 x1 x3 x2 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (Curry_Directory.d_C_getModificationTime x2 cd cs)
    (d_OP_checkTypedFlatCurry_dot_uscore_hash_lambda9_dot_uscore_hash_lambda11_dot_uscore_hash_lambda15
    x2 x3) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_dollar
    Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (Curry_Prelude.d_OP_plus_plus (d_C__case_16 x1 x2 (Curry_Prelude.d_C_not x1
    cd cs) cd cs) (d_C__case_15 x5 x3 (Curry_Prelude.d_C_not x5 cd cs) cd cs) cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_17 x5 x1 x3 x2 l
    cd cs) (d_C__case_17 x5 x1 x3 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_17 x5
    x1 x3 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_17 x5 x1 x3 x2 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "ModuleDeps._case_17" [show x5, show x1, show x3, show x2, show x6] info)
  _ -> failCons cd (consFail "ModuleDeps._case_17" (showCons x6))

d_C__case_15 :: Curry_Prelude.C_Bool -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_15 x5 x3 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "Missing typed FlatCurry file ") x3 cd cs)
    Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_15 x5 x3 l cd cs)
    (d_C__case_15 x5 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_15 x5
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_15 x5 x3 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "ModuleDeps._case_15" [show x5, show x3, show x6] info)
  _ -> failCons cd (consFail "ModuleDeps._case_15" (showCons x6))

d_C__case_16 :: Curry_Prelude.C_Bool -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C__case_16 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "Missing Curry file ") x2 cd cs)
    Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.OP_List
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_16 x1 x2 l cd cs)
    (d_C__case_16 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_16 x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_16 x1 x2 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "ModuleDeps._case_16" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "ModuleDeps._case_16" (showCons x3))

d_C__case_19 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_19 x2 x1 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    Curry_Prelude.OP_List cd cs
  Curry_Prelude.C_False -> d_C__case_18 x2 x1 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_19 x2 x1 l cd cs)
    (d_C__case_19 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_19 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_19 x2 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "ModuleDeps._case_19" [show x2, show x1, show x3] info)
  _ -> failCons cd (consFail "ModuleDeps._case_19" (showCons x3))

d_C__case_18 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_18 x2 x1 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> let x3 = Curry_Prelude.d_C_apply
                                (Curry_Prelude.d_C_apply
                                (Curry_FilePath.d_OP_lt_dot_gt cd cs)
                                (System.Curry_CurryPath.d_C_stripCurrySuffix
                                (System.Curry_CurryPath.d_C_inCurrySubdirModule
                                x1 x2 cd cs) cd cs) cd cs)
                                (Curry_Prelude.toCurryString "tfcy") cd cs
    in Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    (Curry_Directory.d_C_doesFileExist x2 cd cs)
    (d_OP_checkTypedFlatCurry_dot_uscore_hash_lambda9 x2 x3) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_18 x2 x1 l cd cs)
    (d_C__case_18 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_18 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_18 x2 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "ModuleDeps._case_18" [show x2, show x1, show x4] info)
  _ -> failCons cd (consFail "ModuleDeps._case_18" (showCons x4))

